#include <file.au3>
Dim $VER = @OSVersion             ;OS Version
Dim $REBOOT = 1                   ;RebootMode 0-No, 1-When necessary, 2-When finished, 3- 1+2
Dim $AUTOLOGON = 0                ;AutoLogonMode
Dim $INSTALLFILE = @ScriptDir & "\config\" & $VER & ".ini"             ;silent installation
Dim $REBOOTCOUNT = 0
Dim $APPEND = ""
Dim $OS
Dim $PROGRAMMLIST  = ""
Dim $NonSelectable = IniRead (@ScriptDir & "\config\config.ini", "Program", "NonSelectable", "")
Dim $RebootTimer   = IniRead (@ScriptDir & "\config\config.ini", "Program", "RebootTimer", "")
Dim $AdminWarning  = IniRead (@ScriptDir & "\config\config.ini", "Program", "AdminWarning", "")
Dim $AviableItems                ;array
Dim $SelectedItems               ;array
Dim $REBOOTCOUNT       = 0       ;for AutoLogon
Dim $SoftwareToInstall = 0       ;number of items to install (for progress bar)
Dim $ForceGUI          = 0       ;force GUI for non default ini files

If @OSVersion = "WIN_XP"   Then $OS = "Windows XP"
If @OSVersion = "WIN_2000" Then $OS = "Windows 2000"
If @OSVersion = "WIN_98"   Then $OS = "Windows 98"
If @OSVersion = "WIN_ME"   Then $OS = "Windows ME"
If @OSVersion = "WIN_95"   Then $OS = "Windows 95"
If @OSVersion = "WIN_NT4"  Then $OS = "Windows NT4"

; MAIN ------------------------------------------------------------------
commandline()
If $AdminWarning = 1 Then checkadmin ()
If $INSTALLFILE = @ScriptDir & "\config\" & $VER & ".ini" Or $ForceGUI = 1 Then
   FileToArray  ( $InstallFile, $AviableItems )
   AnalyzeArray ( $AviableItems )
   GUI()
   readselection()
Else
   $N = 2
   RegDelete("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\RunOnce", "kTool")
   FileDelete(@TempDir & "\kTool_temp.ini")
   FileToArray  ( $InstallFile, $SelectedItems )
   AnalyzeArray ( $SelectedItems )
   For $i = 0 to UBound ( $SelectedItems ) - 1
      If $SelectedItems [$i][1] = "Section" Then $SoftwareToInstall = $SoftwareToInstall + 1
   Next
EndIf
Install()
If $REBOOT > 1 Then reboot($RebootTimer)
Exit
; END MAIN---------------------------------------------------------------

Func commandline() ; Read command line options
   For $i = 1 to UBound ($CMDLINE) - 1
      Select
         Case $CMDLINE[$i] = "?" Or $CMDLINE[$i] = "/?" Or $CMDLINE[$i] = "help" Or $CMDLINE[$i] = "/help"
            MsgBox(0, "Help", "/? - Displays this message" & @LF & _
                  "filename        - Specify file to read instructions from (Silent mode)" & @LF & _
                  "                        You can create such files in GUI mode" & @LF & _
                  "/GUI                 Forces GUI mode" & @LF &_
                  "reboot             0 - Disable restarting the computer" & @LF & _
                  "                        1 - Enable restarting the computer (default)" & @LF &_
                  "                        2 - Disable but restart when finished" & @LF &_
                  "                        3 - Enable and restart when finished" & @LF & @LF & _
                  "Example:" & @LF & _
                  "   kTool.exe c:\kTool.ini 2")
            Exit
         Case StringIsDigit ( $CMDLINE[$i] )
            Select 
               Case $CMDLINE[$i] = 0
                  $REBOOT = 0
               Case $CMDLINE[$i] = 1
                  $REBOOT = 1
               Case $CMDLINE[$i] = 2
                  $REBOOT = 2
               Case $CMDLINE[$i] = 3
                  $REBOOT = 3
            EndSelect
         Case $CMDLINE[$i] = "/GUI"
            $ForceGUI = 1
         Case StringRight ( $CMDLINE[$i], 4 ) = ".ini"
            $INSTALLFILE = $CMDLINE[$i]
      EndSelect
   Next
EndFunc   ;==>commandline

Func GUI()  ; Display GUI
   Opt ("GUINotifyMode", 1)
   
   GUICreate("kTool v1.0b - " & $OS & " " & @OSServicePack , 510, 420)
   $LABEL_1  = GUISetControl("label",    IniRead (@ScriptDir & "\config\config.ini", "Language", "Aviable", "Aviable Programs"), 20, 10, 160, 20)
   GUISetControlFont($LABEL_1, "" ,600)
   $LABEL_2  = GUISetControl("label",    IniRead (@ScriptDir & "\config\config.ini", "Language", "Selected", "Selected Programs"), 210, 10, 160, 20)
   GUISetControlFont($LABEL_2, "" ,600)
   $LABEL_3  = GUISetControl("label", "(c) edijs@ev.lv", 410, 400, 160, 20)
   $LIST_1   = GUISetControl("list", "List 1", 10, 30, 180, 400, 0x00a00001)
   $LIST_2   = GUISetControl("list", "List 2", 200, 30, 180, 400, 0x00a00001)
   $BUTTON_1 = GUISetControl("button",   IniRead (@ScriptDir & "\config\config.ini", "Language", "Start", "Start"), 390, 320, 110, 30)
   $BUTTON_2 = GUISetControl("button",   IniRead (@ScriptDir & "\config\config.ini", "Language", "Cancel", "Cancel"), 390, 360, 110, 30)
   $BUTTON_3 = GUISetControl("button",   IniRead (@ScriptDir & "\config\config.ini", "Language", "SaveToFile", "Save To File"), 390, 280, 110, 30)
   $CHECK_1  = GUISetControl("checkbox", IniRead (@ScriptDir & "\config\config.ini", "Language", "Autologon", "Autologon"), 410, 250, 110, 20)
   $CHECK_2  = GUISetControl("checkbox", IniRead (@ScriptDir & "\config\config.ini", "Language", "Reboot", "Reboot"), 410, 230, 110, 20)
      
   $DATA1 = $PROGRAMMLIST
   Global $DATA2 = IniRead( $InstallFile, "Config", "AutoSelect", "")
   
   GUISetControlData($LIST_1, $DATA1)
   GUISetControlData($LIST_2, $DATA2)
   
   GUIShow()
   
   While 1
      $MSG = GUIMsg(0)
      Sleep(50)
      If $MSG = -3 Then Exit
      If $MSG = $BUTTON_1 Then                        ;OK button
         If IniRead  ( $InstallFile, "Config", "SaveSelection", "") = 1 Then
            IniWrite ( $InstallFile, "Config", "AutoSelect", $DATA2 )
         EndIf
         ExitLoop
      EndIf
      If $MSG = $BUTTON_2 Then Exit                   ;Cancel button
      If $MSG = $BUTTON_3 Then                        ;Save to File button
         readselection()
         SaveToFile("", 0)
         $SoftwareToInstall = 0
         ;ReDim $INSTALLCOMMANDS [1][$DIMENSIONS]
;         $N = 1
      EndIf
      If $MSG = $CHECK_1 Then                         ;Set AutoLogon on/off
         If $AUTOLOGON = 0 Then
            $AUTOLOGON = 1
         ElseIf $AUTOLOGON = 1 Then
            $AUTOLOGON = 0
         EndIf
      EndIf
      If $MSG = $CHECK_2 Then                         ;Set Reboot when finished on/off
         If $REBOOT < 2 Then
            $REBOOT = $REBOOT + 2
         ElseIf $REBOOT > 1 Then
            $REBOOT = $REBOOT - 2
         EndIf
      EndIf
      
      If $MSG = $LIST_1 Then                          ;Select list
         $CURRENTSELECTION = GUIRead($LIST_1)
         If $CURRENTSELECTION = "" Or StringLeft ($CURRENTSELECTION,1) = $NonSelectable Then
         ElseIf CheckList($DATA2, $CURRENTSELECTION) = 0 Then
            $DATA2 = $DATA2  & "|"  & $CURRENTSELECTION    
            GUISetControlData($LIST_2, $DATA2)
         EndIf
      EndIf
      
      If $MSG = $LIST_2 Then                          ;Selected list
         $CURRENTSELECTION = GUIRead($LIST_2)
         If $CURRENTSELECTION = "" Then
         Else
            $tempstring = $DATA2 & "|"
            $tempstring = StringReplace ( $tempstring, "|" & $currentselection & "|" , "|")
            $DATA2 = StringTrimRight ( $tempstring, 1 )
            GUISetControlData($LIST_2, $DATA2)
         EndIf
      EndIf
      
      
   Wend
   GUIHide()
EndFunc   ;==>GUI

Func readselection()
   $tNumber = UBound ( $AviableItems )
   $j = 1
   $t = 0
   For $i = 0 To $tNumber - 1
      If $AviableItems [$i][1]  = "Section" Then 
         If CheckList($DATA2, $AviableItems [$I][0]) = 1 Then
            $SoftwareToInstall = $SoftwareToInstall + 1
            $t = 1
         Else
            $t = 0
         EndIf
      EndIf
      If $t = 1 Then
         Redim $SelectedItems [$j][2]
         $SelectedItems [$j-1][0] = $AviableItems [$i][0]
         $SelectedItems [$j-1][1] = $AviableItems [$i][1]
         If $AviableItems [$i][1] = "Reboot" Then $REBOOTCOUNT = $REBOOTCOUNT + 1
         $j = $j + 1 
      EndIf
   Next     
EndFunc

Func AutoLogon()   ;Write autologon information to registry
   RegWrite("HKLM\Software\Microsoft\Windows NT\CurrentVersion\WinLogon\", "DefaultUserName", "REG_SZ", @UserName)
   $PASSWORD = InputBox("Password", "Enter password for autologon" & @CR & $REBOOTCOUNT & " restart(s) required", "", "*")
   RegWrite("HKLM\Software\Microsoft\Windows NT\CurrentVersion\WinLogon\", "DefaultPassword", "REG_SZ", $PASSWORD)
   RegWrite("HKLM\Software\Microsoft\Windows NT\CurrentVersion\WinLogon\", "AutoAdminLogon", "REG_SZ", "1")
   RegWrite("HKLM\Software\Microsoft\Windows NT\CurrentVersion\WinLogon\", "AutoLogonCount", "REG_DWORD", $REBOOTCOUNT)
   RegWrite("HKLM\Software\Microsoft\Windows NT\CurrentVersion\WinLogon\", "DefaultDomainName", "REG_SZ", @LogonDomain)
EndFunc   ;==>AutoLogon

Func Install()  ; Execute selected commands
   If $SoftwareToInstall = 0 Then ;check if anything selected
      Exit
   EndIf
   If $AUTOLOGON = 1 And $REBOOTCOUNT > 0 Then AutoLogon()
   ProgressOn("Progress", "Software Installation", "0%", -1, -1, 16)
   Dim $tItems = 0
   Dim $Command
   Dim $tString
   Dim $tNumber
   For $i = 0 To UBound($SelectedItems) - 1
      If StringInStr ( $SelectedItems[$i][0], "=" ) > 0 Then
         $tNumber = StringInStr    ( $SelectedItems[$i][0], "=" )
         $tString = StringTrimLeft ( $SelectedItems[$i][0], $tNumber )
         $tString = StringStripWS  ( $tString, 3 )
      EndIf
      Select
         Case $SelectedItems [$i][1]  = "Section"
            ProgressSet($tItems * 100 / $SoftwareToInstall, Round($tItems * 100 / $SoftwareToInstall) & "%", $SelectedItems[$i][0] )
            $tItems = $tItems + 1            
         Case $SelectedItems [$i][1]  = "Run"
            Run     ($APPEND & $tString, "", @SW_MINIMIZE)
         Case $SelectedItems [$i][1]  = "RunWait"
            RunWait ($APPEND & $tString, "", @SW_MINIMIZE)
         Case $SelectedItems [$i][1]  = "MsiFile"
            RunWait ( 'msiexec /i "' & $append & $tString, "", @SW_MINIMIZE)
         Case $SelectedItems [$i][1]  = "WaitProcess"
            ProcessWaitClose ($tString)
         Case $SelectedItems [$i][1]  = "DosCommand"
            RunWait (@ComSpec & " /c " & $tString, "", @SW_HIDE)      
         Case $SelectedItems [$i][1]  = "AddReg"
            RunWait ('regedit /s "' & $append & $tString & '"' , "", @SW_MINIMIZE)      
         Case $SelectedItems [$i][1]  = "WinWaitClose"
            WinWait ( $tString )
            WinWaitClose ( $tString )
         Case $SelectedItems [$i][1]  = "Reboot"
            If $i = UBound($SelectedItems) - 1 Then reboot($RebootTimer)
            If $REBOOT > 0 And $REBOOT <> 2 Then
               SaveToFile(@TempDir & "\kTool_temp.ini", $i + 1)
               RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\RunOnce", "kTool", "REG_SZ", '"' & @ScriptFullPath & '" ' & @TempDir & "\KTOOL_TEMP.INI 2")
               reboot($RebootTimer)
               ExitLoop 
            EndIf
         Case Else
      EndSelect
   Next
   ProgressSet(100, "Done", "Complete")
   Sleep(500)
   ProgressOff()
EndFunc   ;==>Install

Func SaveToFile($FILENAME, $FROM)   ;  Write selection to file
   If $FILENAME = "" Then
      $FILENAME = FileSaveDialog("title", "c:\", "INI files (*.ini)", 16, "kTool.ini") 
   EndIf
   $FILE = FileOpen($FILENAME, 2)
   If $FILE = -1 Then
      MsgBox(0, "Error", "Unable to open file.")
      Return
   EndIf
   For $i = $From to UBound ( $SelectedItems ) - 1
      If $SelectedItems[$i][1] = "Section" Then
         FileWriteLine($FILE, "[" & $SelectedItems[$i][0] & "]" )
      Else
         FileWriteLine($FILE, $SelectedItems[$i][0])
      EndIf
   Next
   FileClose($FILE)
EndFunc   ;==>SaveToFile

Func reboot($seconds)
   ProgressOn("Restarting", IniRead (@ScriptDir & "\config\config.ini", "Language", "Restarting", "Restarting"), "", -1, -1, 16)
   For $I = $seconds To 0 Step - 1
      Sleep(1000)
      ProgressSet( ( ($seconds - $I) * 100) / $seconds, $I & " seconds")
   Next
   Shutdown(6)
EndFunc   ;==>reboot

Func checkadmin()
   If IsAdmin()=0 Then
      If MsgBox (4,"","Administrator rights required. Continue?") = 7 then Exit
   EndIf
EndFunc

func CheckList ($tString, $tSubstring) ; Check if substring is in the list
   $tString = $tString & "|"
   If StringInStr ($tString, "|" & $tSubstring & "|") > 0 then 
      return 1
   Else
      return 0
   EndIf
EndFunc

Func CorrectSP ($filename, $tempname)
   $temp = IniRead($FILENAME, $tempname, "RequiredSP", "")
   If $temp = "" Then 
      Return 1
   ElseIf $temp <= @OSServicePack Then 
      Return 1
   Else
      Return 0
   EndIf
EndFunc

Func FileToArray ($FileName, ByRef $ArrayName)
   $Append  = IniRead ($FileName, "Config", "Append", "")
      If $Append = "CD" Then $Append = @ScriptDir & "\"
   $tFile   = FileOpen ( $FileName, 0)
   $i = 0
   While 1
      $tLine = FileReadLine ($tFile)
      If @error = -1 Then ExitLoop
      Redim $ArrayName [$i + 1][2]
      $ArrayName [$i][0] = $tLine
      $i = $i + 1
   Wend
EndFunc

Func AnalyzeArray (ByRef $ArrayName)
   $tNumber = UBound ( $ArrayName )
   For $i = 0 To $tNumber - 1
      Select
         Case  StringLeft ( $ArrayName [$i][0], 1)  = "["
               $ArrayName [$i][0] = StringTrimLeft  ( $ArrayName [$i][0], 1 )
               $ArrayName [$i][0] = StringTrimRight ( $ArrayName [$i][0], 1 )
               $ArrayName [$i][1] = "Section"
               If $ArrayName [$i][0] <> "Config" Then
                  $PROGRAMMLIST = $PROGRAMMLIST & "|" & $ArrayName [$i][0]
               EndIf
         Case  StringLeft ( $ArrayName [$i][0], 7)  = "RunWait"
               $ArrayName [$i][1] = "RunWait"
         Case  StringLeft ( $ArrayName [$i][0], 3)  = "Run"
               $ArrayName [$i][1] = "Run"
         Case  StringLeft ( $ArrayName [$i][0], 7)  = "MsiFile"
               $ArrayName [$i][1] = "MsiFile"
         Case  StringLeft ( $ArrayName [$i][0], 11) = "WaitProcess"
               $ArrayName [$i][1] = "WaitProcess"
         Case  StringLeft ( $ArrayName [$i][0], 10) = "DosCommand"
               $ArrayName [$i][1] = "DosCommand"
         Case  StringLeft ( $ArrayName [$i][0], 6)  = "AddReg"
               $ArrayName [$i][1] = "AddReg"
         Case  StringLeft ( $ArrayName [$i][0], 12) = "WinWaitClose"
               $ArrayName [$i][1] = "WinWaitClose"
         Case  StringLeft ( $ArrayName [$i][0], 6)  = "Reboot"
               $ArrayName [$i][1] = "Reboot"
         Case Else
               $ArrayName [$i][1] = ""
      EndSelect    
   Next
EndFunc

